using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_EntityFramework;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_General._1_Datos
{
    public class USR_Usuarios_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }

        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener

        #region Obtener Simple
        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 3;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL=
                            " SELECT " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.id) + " , " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.idPerfil) + " , " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.validacion_nombre) + " , " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.validacion_clave) + " , " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.nombre) + " , " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.sincronizarconAthos) + " , " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.esSuperUsuario) + " , " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.validacion_SuperUsuario) + " , " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.fechaBorrado) + " , " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.administrador) + " , " +
                                nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.idEmpleado) +
                            " FROM " + nameof(USR_Usuarios) + 
                          " WHERE " + nameof(USR_Usuarios.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<USR_Usuarios>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //USR_Perfiles ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idPerfil!=null)
                    {
                        ThreadStart obj_ThreadStart_PERFILES = new ThreadStart(Obtener_Perfil_Modelo_Obtener);
                        Thread obj_Thread_PERFILES = new Thread(obj_ThreadStart_PERFILES);
                        obj_Thread_PERFILES.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[0] = true;
                    }

                    //MAE_Empleados ##########################################################################################
                    if (g_dnm_Modelo_Obtener.idEmpleado != null)
                    {
                        ThreadStart obj_ThreadStart_EMPLEADOS = new ThreadStart(Obtener_Empleado_Modelo_Obtener);
                        Thread obj_Thread_EMPLEADOS = new Thread(obj_ThreadStart_EMPLEADOS);
                        obj_Thread_EMPLEADOS.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Obtener[1] = true;
                    }

                    //GEN_ValoresGenerales ##########################################################################################
                    ThreadStart obj_ThreadStart_VALORESGENERALES = new ThreadStart(Obtener_ValoresGenerales_Modelo_Obtener);
                    Thread obj_Thread_VALORESGENERALES = new Thread(obj_ThreadStart_VALORESGENERALES);
                    obj_Thread_VALORESGENERALES.Start();
                    

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #region Tablas Relacionadas
        private void Obtener_Perfil_Modelo_Obtener()
        {
            try
            {
                USR_Perfiles_Datos obj_USR_Perfiles_Datos = new USR_Perfiles_Datos();
                g_dnm_Modelo_Obtener.USR_Perfiles = obj_USR_Perfiles_Datos.Obtener_Modelo_Por_Id(g_dnm_Modelo_Obtener.idPerfil);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        private void Obtener_Empleado_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEEMPLEADOS_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idEmpleado};
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Empleados = (MAE_Empleados)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[1] = true;
            }
        }
        private void Obtener_ValoresGenerales_Modelo_Obtener()
        {
            try
            {
                GEN_ValoresGenerales_Datos obj_GEN_ValoresGenerales_Datos = new GEN_ValoresGenerales_Datos();
                GEN_ValoresGenerales mdl_GEN_ValoresGenerales= obj_GEN_ValoresGenerales_Datos.Obtener_Modelo_Por_IdUsuario(g_dnm_Modelo_Obtener.id, true, true, true);

                if (mdl_GEN_ValoresGenerales!=null)
                {
                    List<GEN_ValoresGenerales> lst_GEN_ValoresGenerales = new List<GEN_ValoresGenerales>();
                    lst_GEN_ValoresGenerales.Add(mdl_GEN_ValoresGenerales);
                    g_dnm_Modelo_Obtener.GEN_ValoresGenerales = lst_GEN_ValoresGenerales;
                }
                else
                {
                    g_dnm_Modelo_Obtener.GEN_ValoresGenerales = null;
                }
                
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[2] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public bool Validar(string _str_Usuario, string _str_Clave, bool _bol_RecordarClave)
        {
            bool bol_UsuarioValidado_Correctamente = false;

            try
            {
                Encriptador obj_Encriptador = new Encriptador();
                string str_Clave_Encriptada = obj_Encriptador.Encriptar(_str_Clave);

                USR_Usuarios mdl_USR_Usuarios = Obtener_Modelo_Por_NombreClave(_str_Usuario, str_Clave_Encriptada,true);

                if (mdl_USR_Usuarios != null )
                {
                    //Poner si es SuperUsuario o no
                    if (mdl_USR_Usuarios.validacion_SuperUsuario != null && mdl_USR_Usuarios.validacion_SuperUsuario.Equals(obj_Encriptador.Encriptar(mdl_USR_Usuarios.validacion_nombre + obj_Encriptador.Desencriptar(mdl_USR_Usuarios.validacion_clave) + mdl_USR_Usuarios.nombre)))
                    {
                        mdl_USR_Usuarios.esSuperUsuario = true;
                    }
                    else
                    {
                        mdl_USR_Usuarios.esSuperUsuario = false;
                    }

                    //Rellenar los datos del Usuario Validado
                    INTERNO_UsuarioValidado_Modelo mdl_INTERNO_UsuarioValidado_Modelo = new INTERNO_UsuarioValidado_Modelo();
                    mdl_INTERNO_UsuarioValidado_Modelo.id = mdl_USR_Usuarios.id;
                    mdl_INTERNO_UsuarioValidado_Modelo.idPerfil = mdl_USR_Usuarios.idPerfil;
                    mdl_INTERNO_UsuarioValidado_Modelo.nombre = mdl_USR_Usuarios.nombre;
                    mdl_INTERNO_UsuarioValidado_Modelo.sincronizacionAthos = mdl_USR_Usuarios.sincronizarconAthos != null ? mdl_USR_Usuarios.sincronizarconAthos.Value : false;
                    mdl_INTERNO_UsuarioValidado_Modelo.esSuperUsuario = mdl_USR_Usuarios.esSuperUsuario;
                    mdl_INTERNO_UsuarioValidado_Modelo.esAdministrador = mdl_USR_Usuarios.administrador!=null ? mdl_USR_Usuarios.administrador.Value : false;
                    mdl_INTERNO_UsuarioValidado_Modelo.empleado_Asociado = mdl_USR_Usuarios.MAE_Empleados;

                    Variables.G_MDL_USUARIOVALIDADO_MODELO = mdl_INTERNO_UsuarioValidado_Modelo;

                    bol_UsuarioValidado_Correctamente = true;

                    //Grabar en XML
                    Funciones_FicherosXML.ModificarXML_UsuarioClave(_str_Usuario, _str_Clave, _bol_RecordarClave);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Validar), true);
            }

            return bol_UsuarioValidado_Correctamente;
        }
        public bool Validar_DesdeServicio(long _lng_idUsuario)
        {
            bool bol_UsuarioValidado_Correctamente = false;

            try
            {
                Encriptador obj_Encriptador = new Encriptador();

                USR_Usuarios mdl_USR_Usuarios = Obtener_Modelo_Por_Id(_lng_idUsuario, true);

                if (mdl_USR_Usuarios != null )
                {
                    //Poner si es SuperUsuario o no
                    if (mdl_USR_Usuarios.validacion_SuperUsuario != null && mdl_USR_Usuarios.validacion_SuperUsuario.Equals(obj_Encriptador.Encriptar(mdl_USR_Usuarios.validacion_nombre + obj_Encriptador.Desencriptar(mdl_USR_Usuarios.validacion_clave) + mdl_USR_Usuarios.nombre)))
                    {
                        mdl_USR_Usuarios.esSuperUsuario = true;
                    }
                    else
                    {
                        mdl_USR_Usuarios.esSuperUsuario = false;
                    }

                    //Rellenar los datos del Usuario Validado
                    INTERNO_UsuarioValidado_Modelo mdl_INTERNO_UsuarioValidado_Modelo = new INTERNO_UsuarioValidado_Modelo();
                    mdl_INTERNO_UsuarioValidado_Modelo.id = mdl_USR_Usuarios.id;
                    mdl_INTERNO_UsuarioValidado_Modelo.idPerfil = mdl_USR_Usuarios.idPerfil;
                    mdl_INTERNO_UsuarioValidado_Modelo.nombre = mdl_USR_Usuarios.nombre;
                    mdl_INTERNO_UsuarioValidado_Modelo.sincronizacionAthos = mdl_USR_Usuarios.sincronizarconAthos != null ? mdl_USR_Usuarios.sincronizarconAthos.Value : false;
                    mdl_INTERNO_UsuarioValidado_Modelo.esSuperUsuario = mdl_USR_Usuarios.esSuperUsuario;
                    mdl_INTERNO_UsuarioValidado_Modelo.esAdministrador = mdl_USR_Usuarios.administrador != null ? mdl_USR_Usuarios.administrador.Value : false;
                    mdl_INTERNO_UsuarioValidado_Modelo.empleado_Asociado = mdl_USR_Usuarios.MAE_Empleados;

                    Variables.G_MDL_USUARIOVALIDADO_MODELO = mdl_INTERNO_UsuarioValidado_Modelo;

                    bol_UsuarioValidado_Correctamente = true; 
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Validar_DesdeServicio), true);
            }

            return bol_UsuarioValidado_Correctamente;
        }

        public void Cargar(long _lng_idUsuario)
        {
            USR_Usuarios mdl_USR_Usuarios = null;

            try
            {
                mdl_USR_Usuarios = Obtener_Modelo_Por_Id(_lng_idUsuario,true);

                if (mdl_USR_Usuarios != null)
                {
                    Encriptador obj_Encriptador = new Encriptador();

                    //Poner si es SuperUsuario o no
                    if (mdl_USR_Usuarios.validacion_SuperUsuario != null && mdl_USR_Usuarios.validacion_SuperUsuario.Equals(obj_Encriptador.Encriptar(mdl_USR_Usuarios.validacion_nombre + obj_Encriptador.Desencriptar(mdl_USR_Usuarios.validacion_clave) + mdl_USR_Usuarios.nombre)))
                    {
                        mdl_USR_Usuarios.esSuperUsuario = true;
                    }
                    else
                    {
                        mdl_USR_Usuarios.esSuperUsuario = false;
                    }

                    //Rellenar los datos del Usuario Validado
                    INTERNO_UsuarioValidado_Modelo mdl_INTERNO_UsuarioValidado_Modelo = new INTERNO_UsuarioValidado_Modelo();
                    mdl_INTERNO_UsuarioValidado_Modelo.id = mdl_USR_Usuarios.id;
                    mdl_INTERNO_UsuarioValidado_Modelo.idPerfil = mdl_USR_Usuarios.idPerfil;
                    mdl_INTERNO_UsuarioValidado_Modelo.nombre = mdl_USR_Usuarios.nombre;
                    mdl_INTERNO_UsuarioValidado_Modelo.sincronizacionAthos = mdl_USR_Usuarios.sincronizarconAthos != null ? mdl_USR_Usuarios.sincronizarconAthos.Value : false;
                    mdl_INTERNO_UsuarioValidado_Modelo.esSuperUsuario = mdl_USR_Usuarios.esSuperUsuario;
                    mdl_INTERNO_UsuarioValidado_Modelo.esAdministrador = mdl_USR_Usuarios.administrador!=null ? mdl_USR_Usuarios.administrador.Value : false;
                    mdl_INTERNO_UsuarioValidado_Modelo.empleado_Asociado = mdl_USR_Usuarios.MAE_Empleados;

                    Variables.G_MDL_USUARIOVALIDADO_MODELO = mdl_INTERNO_UsuarioValidado_Modelo;

                    //Grabar en XML
                    Funciones_FicherosXML.ModificarXML_UsuarioClave(mdl_USR_Usuarios.validacion_nombre, obj_Encriptador.Desencriptar(mdl_USR_Usuarios.validacion_clave), true);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Cargar), true);
            }
        }

        public bool Comprobar_SuperAdmin()
        {
           
            bool mdl_PRV_Usuarios_existe = false;
            try
            {
                //Obtener el listado de usuarios
                List<USR_Usuarios> lst_PRV_Usuarios=Obtener_ModeloListado_por_Superusuario();

                if (lst_PRV_Usuarios != null && lst_PRV_Usuarios.Count>0)
                {
                    Encriptador obj_Encriptador = new Encriptador();

                    foreach (USR_Usuarios mdl_USR_Usuarios in lst_PRV_Usuarios)
                    {
                        if (mdl_USR_Usuarios.validacion_SuperUsuario != null && mdl_USR_Usuarios.validacion_SuperUsuario.Equals(obj_Encriptador.Encriptar(mdl_USR_Usuarios.validacion_nombre + obj_Encriptador.Desencriptar(mdl_USR_Usuarios.validacion_clave) + mdl_USR_Usuarios.nombre)))
                        {
                            mdl_PRV_Usuarios_existe = true;
                            break;
                        }
                    }
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Comprobar_SuperAdmin), true);
            }

            return mdl_PRV_Usuarios_existe;
        }
        public bool Comprobar_ExisteAdministrador(long _lng_idUsuario_Actual)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            bool mdl_PRV_Usuarios_existe = false;
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                string str_SQL =
                           " SELECT " +
                               nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.id) +
                          " FROM " + nameof(USR_Usuarios) +
                         " WHERE " +
                                    nameof(USR_Usuarios.fechaBorrado) + " is null AND " +
                                    "( not " + nameof(USR_Usuarios.administrador) + " is null ) AND " +
                                    nameof(USR_Usuarios.administrador) + "=@administrador AND " +
                                    nameof(USR_Usuarios.id) + "<>@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@administrador",  true),
                     new SqlParameter("@id",  _lng_idUsuario_Actual)
                };

                //Rellenar 
                long? lg_id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).FirstOrDefault();

                if (lg_id != null && lg_id.Value > 0)
                {
                    mdl_PRV_Usuarios_existe = true;
                }        
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Comprobar_ExisteAdministrador), true);
            }
            finally
            {
                if (obj_Exferia_Entities != null)
                {
                    obj_Exferia_Entities.Database.Connection.Close();
                    obj_Exferia_Entities.Dispose();
                }
            }
            return mdl_PRV_Usuarios_existe;
        }
        
        #endregion

        #region MODELOS

        #region Modelo Simple
        private USR_Usuarios g_mdl_USR_Usuarios = null;
        public USR_Usuarios Obtener_Modelo_Por_Id(long _lng_id,
                                                  bool _bol_Cargar_Empleado)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_Empleado);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_USR_Usuarios;
        }

        public USR_Usuarios Obtener_Modelo_Por_NombreClave(string  _str_Nombre,
                                                  string _str_Clave,
                                                  bool _bol_Cargar_Empleado)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + 
                                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.fechaBorrado) + " is null AND " +
                                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.validacion_nombre) + "=@validacion_nombre AND " +
                                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.validacion_clave) + "=@validacion_clave ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                    new SqlParameter("@validacion_nombre",  _str_Nombre),
                    new SqlParameter("@validacion_clave",  _str_Clave)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros,
                                         _bol_Cargar_Empleado);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_USR_Usuarios;
        }

        #region Ejecutar_Consulta_Modelo
        //Hilos
        private static int g_int_TotalHilos_Modelo = 1;
        private bool[] g_bol_Hilos_Terminados_Modelo = new bool[g_int_TotalHilos_Modelo];

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros,
                                              bool _bol_Cargar_Empleado)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_USR_Usuarios = obj_Exferia_Entities.Database.SqlQuery<USR_Usuarios>(_str_SQL, _arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_mdl_USR_Usuarios != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Modelo[int_Contador] = false;
                    }

                    //MAE_Empleados ##########################################################################################
                    if (_bol_Cargar_Empleado &&
                        g_mdl_USR_Usuarios.idEmpleado!=null)
                    {
                        ThreadStart obj_ThreadStart_EMPLEADO = new ThreadStart(Obtener_Empleados_Modelo);
                        Thread obj_Thread_EMPLEADO = new Thread(obj_ThreadStart_EMPLEADO);
                        obj_Thread_EMPLEADO.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Modelo[0] = true;
                    }

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion


            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        private void Obtener_Empleados_Modelo()
        {
            try
            {
               
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEEMPLEADOS_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);

                //Obtener valores
                object[] arr_Parametros = { g_mdl_USR_Usuarios.idEmpleado.Value };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_mdl_USR_Usuarios.MAE_Empleados = (MAE_Empleados)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo[0] = true;
            }
        }

        #endregion
        #endregion

        #region Modelo Listado
        private List<USR_Usuarios> g_lst_USR_Usuarios = null;

        public List<USR_Usuarios> Obtener_ModeloListado_por_Superusuario()
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                //WHERE
                                " WHERE " + 
                                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.fechaBorrado) + " is Null AND " +
                                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.esSuperUsuario) + " =@esSuperUsuario AND " +
                                    "( not " + nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.validacion_SuperUsuario) + " is Null) ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@esSuperUsuario",  true)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 false,
                                                 false,
                                                 false);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Obtener_ModeloListado_por_Superusuario), true);
            }

            return g_lst_USR_Usuarios;
        }

        public List<USR_Usuarios> Obtener_ModeloListado_por_NoSuperusuario(bool _bol_Cargar_PerfilesPermisos,
                                                                           bool _bol_Cargar_Perfiles,
                                                                           bool _bol_Cargar_Empleados)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                //WHERE
                                " WHERE " +
                                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.fechaBorrado) + " is Null AND " +
                                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.esSuperUsuario) + " =@esSuperUsuario ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@esSuperUsuario",  false)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros,
                                                 _bol_Cargar_PerfilesPermisos,
                                                 _bol_Cargar_Perfiles,
                                                 _bol_Cargar_Empleados);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Obtener_ModeloListado_por_Superusuario), true);
            }

            return g_lst_USR_Usuarios;
        }

        public List<USR_Usuarios> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids,
                                                                bool _bol_Cargar_PerfilesPermisos,
                                                                bool _bol_Cargar_Perfiles,
                                                                bool _bol_Cargar_Empleados)
        {
            try
            {

                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(USR_Usuarios),
                                                                                             nameof(USR_Usuarios.id),
                                                                                             G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                             _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                    " WHERE " +
                                        str_Filtros_IDS;


                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { },
                                                     _bol_Cargar_PerfilesPermisos,
                                                     _bol_Cargar_Perfiles,
                                                     _bol_Cargar_Empleados);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_USR_Usuarios;
        }

        #region Ejecutar Consulta
        //Listado de modelos Relacionados
        private List<USR_Usuarios_Perfiles_Permisos> g_lst_USR_Usuarios_Perfiles_Permisos = null;
        private List<USR_Perfiles> g_lst_USR_Perfiles = null;
        private List<MAE_Empleados> g_lst_MAE_Empleados = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado = 3;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado = new bool[g_int_TotalHilos_Modelo_Listado];

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros,
                                                      bool _bol_Cargar_PerfilesPermisos,
                                                      bool _bol_Cargar_Perfiles,
                                                      bool _bol_Cargar_Empleados)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_USR_Usuarios = obj_Exferia_Entities.Database.SqlQuery<USR_Usuarios>(_str_SQL, _arr_Parametros).ToList();


                #region Rellenar tablas Relacionadas
                if (g_lst_USR_Usuarios != null && g_lst_USR_Usuarios.Count > 0)
                {
                    
                    //Si tiene que buscar alguna tabla relacionada
                    if (_bol_Cargar_PerfilesPermisos ||
                    _bol_Cargar_Perfiles ||
                    _bol_Cargar_Empleados)
                    {
                        #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                        //reiniciar Valores de los hilos
                        for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado; int_Contador++)
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[int_Contador] = false;
                        }

                        //USR_Usuarios_Perfiles_Permisos #############################################
                        if (_bol_Cargar_PerfilesPermisos)
                        {
                            ThreadStart obj_ThreadStart_USUARIOSPERFILESPERMISOS = new ThreadStart(Obtener_UsuariosPerfilesPermisos_Modelo_Listado);
                            Thread obj_Thread_USUARIOSPERFILESPERMISOS = new Thread(obj_ThreadStart_USUARIOSPERFILESPERMISOS);
                            obj_Thread_USUARIOSPERFILESPERMISOS.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
                        }

                        //USR_Perfiles #############################################
                        if (_bol_Cargar_Perfiles)
                        {
                            ThreadStart obj_ThreadStart_PERFILES = new ThreadStart(Obtener_Perfiles_Modelo_Listado);
                            Thread obj_Thread_PERFILES = new Thread(obj_ThreadStart_PERFILES);
                            obj_Thread_PERFILES.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
                        }

                        //MAE_Empleados #############################################
                        if (_bol_Cargar_Empleados)
                        {
                            ThreadStart obj_ThreadStart_EMPLEADOS = new ThreadStart(Obtener_Empleados_Modelo_Listado);
                            Thread obj_Thread_EMPLEADOS = new Thread(obj_ThreadStart_EMPLEADOS);
                            obj_Thread_EMPLEADOS.Start();
                        }
                        else
                        {
                            g_bol_Hilos_Terminados_Modelo_Listado[2] = true;
                        }

                        //Esperando a que terminen todos los hilos .........................................
                        bool bol_Termino = false;
                        while (bol_Termino == false)
                        {
                            bol_Termino = true;
                            foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado)
                            {
                                if (bol_Termino_Hilo == false)
                                {
                                    bol_Termino = false;
                                    break;
                                }
                            }

                            Thread.Sleep(10);
                        }
                        //.................................................................................
                        #endregion

                        #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                        foreach (USR_Usuarios mdl_USR_Usuarios in g_lst_USR_Usuarios)
                        {

                            //USR_Usuarios_Perfiles_Permisos #############################################
                            if (_bol_Cargar_PerfilesPermisos &&
                                g_lst_USR_Usuarios_Perfiles_Permisos != null &&
                                g_lst_USR_Usuarios_Perfiles_Permisos.Count > 0)
                            {
                                mdl_USR_Usuarios.USR_Usuarios_Perfiles_Permisos = g_lst_USR_Usuarios_Perfiles_Permisos.Where(m => m.idUsuario != null && m.idUsuario.Value == mdl_USR_Usuarios.id).ToList();
                            }

                            //USR_Perfiles #############################################
                            if (_bol_Cargar_Perfiles &&
                                mdl_USR_Usuarios.idPerfil != null &&
                                g_lst_USR_Perfiles != null &&
                                g_lst_USR_Perfiles.Count > 0)
                            {
                                mdl_USR_Usuarios.USR_Perfiles = g_lst_USR_Perfiles.Where(m => m.id == mdl_USR_Usuarios.idPerfil.Value).FirstOrDefault();
                            }

                            //MAE_Empleados #############################################
                            if (_bol_Cargar_Empleados &&
                                mdl_USR_Usuarios.idEmpleado != null &&
                                g_lst_MAE_Empleados != null &&
                                g_lst_MAE_Empleados.Count > 0)
                            {
                                mdl_USR_Usuarios.MAE_Empleados = g_lst_MAE_Empleados.Where(m => m.id == mdl_USR_Usuarios.idEmpleado.Value).FirstOrDefault();
                            }


                        }
                        #endregion
                    }
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #region Tablas Relacionadas
        private void Obtener_UsuariosPerfilesPermisos_Modelo_Listado()
        {
            try
            {
                USR_Usuarios_Perfiles_Permisos_Datos obj_USR_Usuarios_Perfiles_Permisos_Datos = new USR_Usuarios_Perfiles_Permisos_Datos();
                g_lst_USR_Usuarios_Perfiles_Permisos = obj_USR_Usuarios_Perfiles_Permisos_Datos.Obtener_ModeloListado_Por_IdsUsuario(g_lst_USR_Usuarios.Select(m => m.id).ToList(),false,false, true);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[0] = true;
            }
        }
        private void Obtener_Perfiles_Modelo_Listado()
        {
            try
            {
                USR_Perfiles_Datos obj_USR_Perfiles_Datos = new USR_Perfiles_Datos();
                g_lst_USR_Perfiles = obj_USR_Perfiles_Datos.Obtener_ModeloListado_Por_Ids(g_lst_USR_Usuarios.Where(m=>m.idPerfil!=null).Select(m => m.idPerfil.Value).ToList(), true);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[1] = true;
            }
        }
        private void Obtener_Empleados_Modelo_Listado()
        {
            try
            {
                List<long> lst_idsEmpleados = g_lst_USR_Usuarios.Where(m => m.idEmpleado != null).Select(m => m.idEmpleado.Value).ToList();
                if (lst_idsEmpleados != null && lst_idsEmpleados.Count > 0)
                {
                    //Cargamos el ensamblado
                    Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                    //Obtenemos el tipo de la clase
                    Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                    //creamos la instancia
                    var obj_Clase = Activator.CreateInstance(m_type);
                    //Cargamos el metodo solicitado
                    MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEEMPLEADOS_OBTENERMODELOLISTADO_POR_IDS, BindingFlags.Instance | BindingFlags.NonPublic);

                    //Obtener valores
                    object[] arr_Parametros = { lst_idsEmpleados };
                    //Pasamos los parametros al metodo y lo ejecutamos
                    g_lst_MAE_Empleados = (List<MAE_Empleados>)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
                }
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado[2] = true;
            }
        }

        #endregion
        #endregion


        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.id) + " , " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.idPerfil) + " , " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.validacion_nombre) + " , " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.validacion_clave) + " , " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.nombre) + " , " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.sincronizarconAthos) + " , " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.esSuperUsuario) + " , " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.validacion_SuperUsuario) + " , " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.fechaBorrado) + " , " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.administrador) + " , " +
                    nameof(USR_Usuarios) + "." + nameof(USR_Usuarios.idEmpleado) +
                " FROM " + nameof(USR_Usuarios);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                USR_Usuarios mdl_USR_Usuarios_AGrabar = (USR_Usuarios)_mdl_obj;
                USR_Usuarios mdl_USR_Usuarios_DatosViejos = new USR_Usuarios();

                // Ver si existe ######################################################################
                USR_Usuarios mdl_USR_Usuarios_Final = Obtener_Modelo_Por_Id(mdl_USR_Usuarios_AGrabar.id,false);
                //######################################################################################             

                if (mdl_USR_Usuarios_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_USR_Usuarios_Final, mdl_USR_Usuarios_DatosViejos, false, false);

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_USR_Usuarios_AGrabar, mdl_USR_Usuarios_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(USR_Usuarios) +
                                            " SET " +
                                                nameof(USR_Usuarios.idPerfil) + "=@idPerfil," +
                                                nameof(USR_Usuarios.validacion_nombre) + "=@validacion_nombre," +
                                                nameof(USR_Usuarios.validacion_clave) + "=@validacion_clave," +
                                                nameof(USR_Usuarios.nombre) + "=@nombre," +
                                                nameof(USR_Usuarios.sincronizarconAthos) + "=@sincronizarconAthos," +
                                                nameof(USR_Usuarios.esSuperUsuario) + "=@esSuperUsuario," +
                                                nameof(USR_Usuarios.validacion_SuperUsuario) + "=@validacion_SuperUsuario," +
                                                nameof(USR_Usuarios.fechaBorrado) + "=@fechaBorrado," +
                                                nameof(USR_Usuarios.administrador) + "=@administrador," +
                                                nameof(USR_Usuarios.idEmpleado) + "=@idEmpleado " +
                                            " WHERE " +
                                                nameof(USR_Usuarios.id) + "=@id";


                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                       mdl_USR_Usuarios_AGrabar.idPerfil!=null
                            ?   new SqlParameter("@idPerfil",  mdl_USR_Usuarios_AGrabar.idPerfil.Value)
                            :   new SqlParameter("@idPerfil",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.validacion_nombre!=null
                            ?   new SqlParameter("@validacion_nombre", mdl_USR_Usuarios_AGrabar.validacion_nombre)
                            :   new SqlParameter("@validacion_nombre",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.validacion_clave!=null
                            ?   new SqlParameter("@validacion_clave", mdl_USR_Usuarios_AGrabar.validacion_clave)
                            :   new SqlParameter("@validacion_clave",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.nombre!=null
                            ?   new SqlParameter("@nombre", mdl_USR_Usuarios_AGrabar.nombre)
                            :   new SqlParameter("@nombre",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.sincronizarconAthos!=null
                            ?   new SqlParameter("@sincronizarconAthos", mdl_USR_Usuarios_AGrabar.sincronizarconAthos.Value)
                            :   new SqlParameter("@sincronizarconAthos",  DBNull.Value),
                        new SqlParameter("@esSuperUsuario",  mdl_USR_Usuarios_AGrabar.esSuperUsuario),
                        mdl_USR_Usuarios_AGrabar.validacion_SuperUsuario!=null
                            ?   new SqlParameter("@validacion_SuperUsuario", mdl_USR_Usuarios_AGrabar.validacion_SuperUsuario)
                            :   new SqlParameter("@validacion_SuperUsuario",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_USR_Usuarios_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.administrador!=null
                            ?   new SqlParameter("@administrador", mdl_USR_Usuarios_AGrabar.administrador.Value)
                            :   new SqlParameter("@administrador",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.idEmpleado!=null
                            ?   new SqlParameter("@idEmpleado", mdl_USR_Usuarios_AGrabar.idEmpleado.Value)
                            :   new SqlParameter("@idEmpleado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_USR_Usuarios_AGrabar.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_USR_Usuarios_AGrabar.id;
                }
                else
                {
                    mdl_USR_Usuarios_Final = new USR_Usuarios();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_USR_Usuarios_AGrabar, mdl_USR_Usuarios_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(USR_Usuarios) +
                                                " (" +
                                                        nameof(USR_Usuarios.idPerfil) + "," +
                                                        nameof(USR_Usuarios.validacion_nombre) + "," +
                                                        nameof(USR_Usuarios.validacion_clave) + "," +
                                                        nameof(USR_Usuarios.nombre) + "," +
                                                        nameof(USR_Usuarios.sincronizarconAthos) + "," +
                                                        nameof(USR_Usuarios.esSuperUsuario) + "," +
                                                        nameof(USR_Usuarios.validacion_SuperUsuario) + "," +
                                                        nameof(USR_Usuarios.fechaBorrado) + "," +
                                                        nameof(USR_Usuarios.administrador) + "," +
                                                        nameof(USR_Usuarios.idEmpleado) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(USR_Usuarios.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idPerfil," +
                                                    "@validacion_nombre," +
                                                    "@validacion_clave," +
                                                    "@nombre," +
                                                    "@sincronizarconAthos," +
                                                    "@esSuperUsuario," +
                                                    "@validacion_SuperUsuario," +
                                                    "@fechaBorrado," +
                                                    "@administrador," +
                                                    "@idEmpleado" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                       mdl_USR_Usuarios_AGrabar.idPerfil!=null
                            ?   new SqlParameter("@idPerfil",  mdl_USR_Usuarios_AGrabar.idPerfil.Value)
                            :   new SqlParameter("@idPerfil",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.validacion_nombre!=null
                            ?   new SqlParameter("@validacion_nombre", mdl_USR_Usuarios_AGrabar.validacion_nombre)
                            :   new SqlParameter("@validacion_nombre",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.validacion_clave!=null
                            ?   new SqlParameter("@validacion_clave", mdl_USR_Usuarios_AGrabar.validacion_clave)
                            :   new SqlParameter("@validacion_clave",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.nombre!=null
                            ?   new SqlParameter("@nombre", mdl_USR_Usuarios_AGrabar.nombre)
                            :   new SqlParameter("@nombre",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.sincronizarconAthos!=null
                            ?   new SqlParameter("@sincronizarconAthos", mdl_USR_Usuarios_AGrabar.sincronizarconAthos.Value)
                            :   new SqlParameter("@sincronizarconAthos",  DBNull.Value),
                        new SqlParameter("@esSuperUsuario",  mdl_USR_Usuarios_AGrabar.esSuperUsuario),
                        mdl_USR_Usuarios_AGrabar.validacion_SuperUsuario!=null
                            ?   new SqlParameter("@validacion_SuperUsuario", mdl_USR_Usuarios_AGrabar.validacion_SuperUsuario)
                            :   new SqlParameter("@validacion_SuperUsuario",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_USR_Usuarios_AGrabar.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.administrador!=null
                            ?   new SqlParameter("@administrador", mdl_USR_Usuarios_AGrabar.administrador.Value)
                            :   new SqlParameter("@administrador",  DBNull.Value),
                        mdl_USR_Usuarios_AGrabar.idEmpleado!=null
                            ?   new SqlParameter("@idEmpleado", mdl_USR_Usuarios_AGrabar.idEmpleado.Value)
                            :   new SqlParameter("@idEmpleado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(USR_Usuarios), mdl_USR_Usuarios_DatosViejos, mdl_USR_Usuarios_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public void Crear_SuperAdmin()
        {
            Encriptador obj_Encriptador = new Encriptador();

            Exferia_Entities obj_Exferia_Entities = null;

            
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();


                #region INSERT
                string str_SQL_Insert = " INSERT INTO " + nameof(USR_Usuarios) +
                                            " (" +
                                                    nameof(USR_Usuarios.idPerfil) + "," +
                                                    nameof(USR_Usuarios.validacion_nombre) + "," +
                                                    nameof(USR_Usuarios.validacion_clave) + "," +
                                                    nameof(USR_Usuarios.nombre) + "," +
                                                    nameof(USR_Usuarios.sincronizarconAthos) + "," +
                                                    nameof(USR_Usuarios.esSuperUsuario) + "," +
                                                    nameof(USR_Usuarios.validacion_SuperUsuario) + "," +
                                                    nameof(USR_Usuarios.fechaBorrado) + "," +
                                                    nameof(USR_Usuarios.administrador) + "," +
                                                    nameof(USR_Usuarios.idEmpleado) +
                                            " ) " +
                                            " VALUES " +
                                            " ( " +
                                                    "@idPerfil," +
                                                    "@validacion_nombre," +
                                                    "@validacion_clave," +
                                                    "@nombre," +
                                                    "@sincronizarconAthos," +
                                                    "@esSuperUsuario," +
                                                    "@validacion_SuperUsuario," +
                                                    "@fechaBorrado," +
                                                    "@administrador," +
                                                    "@idEmpleado " +
                                            " ) ";
                //Parametros
                object[] arr_Parametros_Insert = new object[]
                {
                     Variables.G_LONG_SUPERADMIN_IDPERFIL!=null
                            ?   new SqlParameter("@idPerfil",  Variables.G_LONG_SUPERADMIN_IDPERFIL.Value)
                            :   new SqlParameter("@idPerfil",  DBNull.Value),

                    new SqlParameter("@validacion_nombre", Variables.G_STR_SUPERADMIN_VALIDACION_NOMBRE),
                    new SqlParameter("@validacion_clave",  obj_Encriptador.Encriptar(Variables.G_STR_SUPERADMIN_VALIDACION_CLAVE)),
                    new SqlParameter("@nombre",  Variables.G_STR_SUPERADMIN_NOMBRE_MOSTRAR),
                    new SqlParameter("@sincronizarconAthos",  false),
                    new SqlParameter("@esSuperUsuario", true),
                    new SqlParameter("@validacion_SuperUsuario",  obj_Encriptador.Encriptar(Variables.G_STR_SUPERADMIN_VALIDACION_NOMBRE + Variables.G_STR_SUPERADMIN_VALIDACION_CLAVE + Variables.G_STR_SUPERADMIN_NOMBRE_MOSTRAR)),
                    new SqlParameter("@fechaBorrado",  DBNull.Value),
                    new SqlParameter("@administrador",  DBNull.Value),
                    new SqlParameter("@idEmpleado",  DBNull.Value)
                };
                #endregion

                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Insert, arr_Parametros_Insert);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Crear_SuperAdmin), true);
            }
            finally
            {
                if (obj_Exferia_Entities != null)
                {
                    obj_Exferia_Entities.Database.Connection.Close();
                    obj_Exferia_Entities.Dispose();
                }
            }
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;
           
            try
            {

                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                USR_Usuarios mdl_USR_Usuarios_Final = Obtener_Modelo_Por_Id(_lng_id,false);
                //######################################################################################

                if (mdl_USR_Usuarios_Final != null)
                {

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(USR_Usuarios) +
                                                " SET " +
                                                nameof(USR_Usuarios.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(USR_Usuarios.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                 new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(USR_Usuarios), null, mdl_USR_Usuarios_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }
                
                // Devolver también el Objeto
                mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(USR_Usuarios_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        #endregion
    }
}
